"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = reloadSession;

var _logger = _interopRequireDefault(require("@wdio/logger"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = (0, _logger.default)('webdriverio');

async function reloadSession() {
  const oldSessionId = this.sessionId;

  try {
    await this.deleteSession();
  } catch (err) {
    log.warn(`Suppressing error closing the session: ${err.stack}`);
  }

  const ProtocolDriver = require(this.options.automationProtocol).default;

  await ProtocolDriver.reloadSession(this);

  if (Array.isArray(this.options.onReload) && this.options.onReload.length) {
    await Promise.all(this.options.onReload.map(hook => hook(oldSessionId, this.sessionId)));
  }

  return this.sessionId;
}