"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isEqual;

var _constants = require("../../constants");

var _utils = require("../../utils");

const getWebElement = el => ({
  [_constants.ELEMENT_KEY]: el.elementId,
  ELEMENT: el.elementId
});

async function isEqual(el) {
  const browser = (0, _utils.getBrowserObject)(this);

  if (browser.isMobile) {
    const context = await browser.getContext();

    if (context.toLowerCase().includes('native')) {
      return this.elementId === el.elementId;
    }
  }

  let result;

  try {
    result = await browser.execute((el1, el2) => el1 === el2, getWebElement(this), getWebElement(el));
  } catch (err) {
    result = false;
  }

  return result;
}